#include <iostream>

using namespace std;

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int n, q;
    long long dan, r, razlika, t;
    cin >> n >> q;
    long long k[q], d[n], p[n];
    for(int i = 0; i < n; i++) cin >> d[i] >> p[i];
    for(int i = 0; i < q; i++) cin >> k[i];
    for(int i = 0; i < q; i++) {
        r = 0;
        dan = d[0];
        if(k[i] < d[0]);
        else {
            for(int j = 0; j < n; j++) {
                if(dan > d[j]) {
                    if(dan + p[j] - 1 >= k[i]) {
                        r+= k[i]-dan+1;
                        break;
                    }
                    else {
                        r+=p[j];
                        dan += p[j]-1;
                    }
                }
                else {
                    if(d[j] + p[j] - 1 >= k[i]) {
                        r+= k[i]-d[j]+1;
                        break;
                    }
                    else {
                        r+=p[j];
                        dan = d[j] + p[j]-1;
                    }
                }
            }
        }
        cout << r << endl;
    }

    return 0;
}